<?php
/*
  Plugin Name: KVS Player Pro
  Version: 4.1
  Author: CyberSEO.net
  Author URI: http://www.cyberseo.net/
  Plugin URI: http://www.cyberseo.net/kvs-player-pro/
  Description: The KVS Player Pro plugin allows one to easily embed videos (FLV, F4V and MP4 files) into WordPress blogs.
 */

if (!defined('ABSPATH')) {
    require_once("../../../wp-config.php");
    status_header(404);
    nocache_headers();
    include(get_404_template());
    exit();
}

define('KVS_PLAYER_DEFAULT_PLAYER_SWF', plugins_url('/kt_player/kt_player.swf', __FILE__));
define('KVS_PLAYER_DEFAULT_PLAYER_JS', plugins_url('/kt_player/kt_player.js', __FILE__));
define('KVS_PLAYER_OPTIONS', 'kvs_player_options');

function kvs_player_file_get_contents($url) {
    if (parse_url($url, PHP_URL_SCHEME) != "" && function_exists('curl_init')) {
        $max_redirects = 10;
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_USERAGENT, 'kvs_player');
        curl_setopt($ch, CURLOPT_ENCODING, 'gzip,deflate');
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        if (ini_get('open_basedir') == '' && (ini_get('safe_mode' == 'Off') || !ini_get('safe_mode'))) {
            curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
            curl_setopt($ch, CURLOPT_MAXREDIRS, $max_redirects);
        } else {
            curl_setopt($ch, CURLOPT_FOLLOWLOCATION, false);
            $rch = curl_copy_handle($ch);
            curl_setopt($rch, CURLOPT_HEADER, true);
            curl_setopt($rch, CURLOPT_NOBODY, true);
            curl_setopt($rch, CURLOPT_FORBID_REUSE, false);
            curl_setopt($rch, CURLOPT_RETURNTRANSFER, true);
            do {
                curl_setopt($rch, CURLOPT_URL, $url);
                $header = curl_exec($rch);
                if (curl_errno($rch)) {
                    $code = 0;
                } else {
                    $code = curl_getinfo($rch, CURLINFO_HTTP_CODE);
                    if ($code == 301 || $code == 302) {
                        preg_match('/Location:(.*?)\n/', $header, $matches);
                        $url = trim(array_pop($matches));
                    } else {
                        $code = 0;
                    }
                }
            } while ($code && --$max_redirects);
            curl_close($rch);
            curl_setopt($ch, CURLOPT_URL, $url);
        }
        $content = curl_exec($ch);
        $code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
        curl_close($ch);
        if ($code != 200) {
            return false;
        }
    }
    return $content;
}

$kvs_player_default_options = array(
    'height' => '480',
    'width' => '854',
    'hide_controlbar' => '1',
    'hide_style' => 'fade',
    'autoplay' => '0',
    'skin' => '',
    'preview_url' => '',
    'scaling' => '',
    'autoplay' => '0',
    'embed' => '',
    'iframe' => '',
    'permalink' => '',
    'sec' => '',
    'bt' => '5',
    'encode' => '',
    'flv_stream' => '',
    'logo_src' => '',
    'logo_url' => '',
    'logo_anchor' => '',
    'logo_position_x' => '0',
    'logo_position_y' => '0',
    'mlogo' => '',
    'mlogo_link' => '',
    'urls_in_same_window' => '',
    'video_click_url' => '',
    'adv_start_html_id' => '',
    'adv_pre_roll_sw_html' => '',
    'adv_pre_html_id' => '',
    'adv_pre_roll_sw_flash' => '',
    'adv_pre_src' => '',
    'adv_pre_duration' => '',
    'adv_pre_url' => '',
    'adv_post_roll_sw_html' => '',
    'adv_post_html_id' => '',
    'adv_post_src' => '',
    'adv_post_roll_sw_flash' => '',
    'adv_post_duration' => '',
    'adv_post_url' => '',
    'adv_pause_roll_sw_html' => '',
    'adv_pause_html_id' => '',
    'adv_pause_roll_sw_flash' => '',
    'adv_pause_src' => '',
    'adv_pause_url' => '',
    'adv_mover_src' => '',
    'adv_mover_url' => '',
    'html_code' => '<div id="player_adv_start" style="position: absolute; width: 427px; height: 240px; background: #aaa; display: none; text-align: center">
    Advertising: player_adv_start<br/>
    <a href="#" class="kt-api-btn-start">Click here to close</a>
</div>

<div id="player_adv_pre" style="position: absolute; width: 427px; height: 240px; background: #aaa; display: none; text-align: center">
    Advertising: player_adv_pre<br/>
    <span class="kt-api-time-left">&nbsp;</span> seconds left
</div>

<div id="player_adv_post" style="position: absolute; width: 427px; height: 240px; background: #aaa; display: none; text-align: center">
    Advertising: player_adv_post
</div>

<div id="player_adv_pause" style="position: absolute; width: 427px; height: 240px; background: #aaa; display: none; text-align: center">
    Advertising: player_adv_pause<br/>
    <a href="#" class="kt-api-btn-start">Click here to continue</a>
</div>',
);

$kvs_players = 0;
$codes = array();
$kvs_player_options = get_option(KVS_PLAYER_OPTIONS, array());
foreach ($kvs_player_default_options as $item => $value) {
    if (!isset($kvs_player_options[$item])) {
        $kvs_player_options[$item] = $value;
    }
}

if (is_admin() && isset($_POST['save_changes'])) {
    unset($_POST['save_changes']);
    foreach ($_POST as $option => $value) {
        $kvs_player_options[$option] = $value;
    }
    update_option(KVS_PLAYER_OPTIONS, $kvs_player_options);
}

function kvs_player_general_options_menu() {
    global $kvs_player_options;
    ?>
    <div class="wrap">
        <?php
        echo kvs_player_file_get_contents('https://www.cyberseo.net/info/CyberSEO/ad-common.php');
        ?>
        <h2>KVS Player Pro General Options</h2>
        <div class="metabox-holder postbox-container xpinner-settings">
            <form name="general_options_menu" action="" method="post">
                <div class="section" id="player_configurator_visual" style="display: block">
                    <table class="form-table">
                        <tr>
                            <th scope="row">
                                Player size (*):
                            </th>
                            <td>
                                <input type="text" id="width" name="width" value="<?php echo $kvs_player_options['width']; ?>" size="6"/>
                                x
                                <input type="text" id="height" name="height" value="<?php echo $kvs_player_options['height']; ?>" size="6"/>
                                <input type="button" class="button" value="100%" onclick="$('#width, #height').val('100%')"/>
                                <p class="description">specify player size in pixels or 100% to force player be sized dynamically based on the container</p>
                            </td>
                        </tr>
                        <tr>
                            <th scope="row">
                                Toolbar behavior:
                            </th>
                            <td>
                                <select id="hide_controlbar" name="hide_controlbar">
                                    <option value=""<?php echo (($kvs_player_options['hide_controlbar'] == '') ? ' selected' : ''); ?>>Show always</option>
                                    <option value="1"<?php echo (($kvs_player_options['hide_controlbar'] == '1') ? ' selected' : ''); ?>>Autohide</option>
                                    <option value="2"><?php echo (($kvs_player_options['hide_controlbar'] == '2') ? ' selected' : ''); ?>Never Show</option>
                                </select>
                                <p class="description">configures how toolbar behaves in preview mode; doesn't affect fullscreen</p>
                            </td>
                        </tr>
                        <tr>
                            <th scope="row">
                                Toolbar autohide style:
                            </th>
                            <td>
                                <select id="hide_style" name="hide_style">
                                    <option value=""<?php echo (($kvs_player_options['hide_style'] == '') ? ' selected' : ''); ?>>Move out</option>
                                    <option value="fade"<?php echo (($kvs_player_options['hide_style'] == 'fade') ? ' selected' : ''); ?>>Fade out</option>
                                </select>
                                <p class="description">configures how toolbar is being hidden in fullscreen and in preview mode when autohide is selected</p>
                            </td>
                        </tr>
                        <tr>
                            <th scope="row">
                                Skin:
                            </th>
                            <td>
                                <select id="skin" name="skin">
                                    <option value=""<?php echo (($kvs_player_options['skin'] == '') ? ' selected' : ''); ?>>Black (default)</option>
                                    <option value="2"<?php echo (($kvs_player_options['skin'] == '2') ? ' selected' : ''); ?>>White</option>
                                </select>
                                <p class="description">select one of the available player skins</p>
                            </td>
                        </tr>
                        <tr>
                            <th scope="row">
                                Poster image:
                            </th>
                            <td>
                                <input type="text" id="preview_url" name="preview_url" value="<?php echo $kvs_player_options['preview_url']; ?>" size="40"/>
                                <input type="button" class="button" value="Example" onclick="$('#preview_url').val('<?php echo plugins_url('/images/poster.jpg', __FILE__); ?>')"/>
                                <p class="description">poster image should be hosted on the same domain or should not have hotlink protection in case of crossdomain</p>
                            </td>
                        </tr>
                        <tr>
                            <th scope="row">
                                Video proportions:
                            </th>
                            <td>
                                <select id="scaling" name="scaling">
                                    <option value=""<?php echo (($kvs_player_options['scaling'] == '') ? ' selected' : ''); ?>>Keep video proportions</option>
                                    <option value="fill"<?php echo (($kvs_player_options['scaling'] == 'fill') ? ' selected' : ''); ?>>Scale to fit player size</option>
                                    <option value="crop"<?php echo (($kvs_player_options['scaling'] == 'crop') ? ' selected' : ''); ?>>Crop to fit player size</option>
                                </select>
                                <p class="description">keeping video proportions may result in black bars; scaling video to fit player size may distort original video proportions; cropping video to fit player size may crop edges to adjust video</p>
                            </td>
                        </tr>
                        <tr>
                            <th scope="row">
                                Autoplay:
                            </th>
                            <td>
                                <select id="autoplay" name="autoplay">
                                    <option value="0"<?php echo (($kvs_player_options['autoplay'] == '') ? ' selected' : ''); ?>>Disabled</option>
                                    <option value="1"<?php echo (($kvs_player_options['autoplay'] == '1') ? ' selected' : ''); ?>>Enabled for single posts and pages only</option>
                                    <option value="2"<?php echo (($kvs_player_options['autoplay'] == '2') ? ' selected' : ''); ?>>Enabled anywhere, including the main page</option>
                                </select>
                                enable/disable autoplay
                            </td>
                        </tr>
                        <tr>
                            <th scope="row">
                                Embed code:
                            </th>
                            <td>
                                <input type="hidden" name="embed" value="">
                                <input type="checkbox" id="embed" name="embed" value="1"<?php if ($kvs_player_options['embed'] == '1') echo " checked"; ?>/>
                                enable embed code
                                <p class="description">if enabled, the player will allow to get embed code</p>
                            </td>
                        </tr>
                        <tr>
                            <th scope="row">
                                Show in iframe:
                            </th>
                            <td>
                                <input type="hidden" name="iframe" value="">
                                <input type="checkbox" id="iframe" name="iframe" value="1"<?php if ($kvs_player_options['iframe'] == '1') echo " checked"; ?>/>
                                show player in iframe
                                <p class="description">if enabled, the player will be shown in an iframe. In this mode the embed codes will be also generated as iframes. So all your advertisements, branding and logos will be shown at 3rd-party websites.</p>
                            </td>
                        </tr>
                        <tr>
                            <th scope="row">
                                Permalink:
                            </th>
                            <td>
                                <input type="hidden" name="permalink" value="">
                                <input type="checkbox" id="permalink" name="permalink" value="1"<?php if ($kvs_player_options['permalink'] == '1') echo " checked"; ?>/>
                                enable permalink URL
                                <p class="description">if provided, player will allow to get permalink of the current post or page</p>
                            </td>
                        </tr>
                        <tr>
                            <th scope="row">
                                Limit video playback:
                            </th>
                            <td>
                                <input type="text" id="sec" name="sec" value="<?php echo $kvs_player_options['sec']; ?>" size="10"/>
                                <p class="description">specify number of seconds to limit video playback</p>
                            </td>
                        </tr>
                        <tr>
                            <th scope="row">
                                Buffer time:
                            </th>
                            <td>
                                <input type="text" id="bt" name="bt" value="<?php echo $kvs_player_options['bt']; ?>" size="10"/>
                                <p class="description">specify length of buffer in seconds; player will start playing after its buffer is fully pre-loaded</p>
                            </td>
                        </tr>
                        <tr>
                            <th scope="row">
                                Disable streaming:
                            </th>
                            <td>
                                <input type="hidden" name="flv_stream" value="">
                                <input type="checkbox" id="flv_stream" name="flv_stream" value="false"<?php if ($kvs_player_options['flv_stream'] == 'false') echo " checked"; ?>/>
                                server does not support streaming / seeking
                                <p class="description">disable streaming if your server does not support streaming / seeking</p>
                            </td>
                        </tr>

                        <tr>
                            <th scope="row">
                                Encode player:
                            </th>
                            <td>
                                <input type="hidden" name="encode" value="">
                                <input type="checkbox" id="encode" name="encode" value="false"<?php if ($kvs_player_options['encode'] == 'false') echo " checked"; ?>/>
                                hide your media
                                <p class="description">if enabled, the player will be encoded. Use this option to hide your media (video file and preview image sources) from theft.</p>
                            </td>
                        </tr>

                    </table>
                    <br />
                    <?php wp_nonce_field('save_changes'); ?>
                    <input type="submit" name="save_changes" class="button-primary" value="Save Changes" />
                </div>
            </form>
        </div>
    </div>
    <?php
}

function kvs_player_branding_menu() {
    global $kvs_player_options;
    ?>
    <script type="text/javascript" src="//ajax.googleapis.com/ajax/libs/jquery/1.10.2/jquery.min.js"></script>
    <div class="wrap">
        <h2>KVS Player Pro Branding Settings</h2>
        <div class="metabox-holder postbox-container xpinner-settings">
            <form name="branding_menu" action="" method="post">
                <div class="section" id="player_configurator_visual" style="display: block">
                    <table class="form-table">
                        <tr>
                            <th scope="row">
                                Logo image:
                            </th>
                            <td>
                                <input type="text" id="logo_src" name="logo_src" value="<?php echo $kvs_player_options['logo_src']; ?>" size="40"/>
                                <input type="button" class="button" value="Example" onclick="$('#logo_src').val('<?php echo plugins_url('/images/logo.png', __FILE__); ?>')"/>
                                <p class="description">specify your logo image to be displayed on top of player; should be hosted on the same domain or should not have hotlink protection in case of crossdomain</p>
                            </td>
                        </tr>
                        <tr>
                            <th scope="row">
                                Logo click URL:
                            </th>
                            <td>
                                <input type="text" id="logo_url" name="logo_url" value="<?php echo $kvs_player_options['logo_url']; ?>" size="40"/>
                                <input type="button" class="button" value="Example" onclick="$('#logo_url').val('http://www.kernel-video-sharing.com/')"/>
                                <p class="description">specify where users will go if they click on your logo</p>
                            </td>
                        </tr>
                        <tr>
                            <th scope="row">
                                Logo position:
                            </th>
                            <td>
                                <select id="logo_anchor" name="logo_anchor">
                                    <option value=""<?php echo (($kvs_player_options['logo_anchor'] == '') ? ' selected' : ''); ?>>Top-left</option>
                                    <option value="topright"<?php echo (($kvs_player_options['logo_anchor'] == 'topright') ? ' selected' : ''); ?>>Top-right</option>
                                    <option value="bottomright"<?php echo (($kvs_player_options['logo_anchor'] == 'bottomright') ? ' selected' : ''); ?>>Bottom-right</option>
                                    <option value="bottomleft"<?php echo (($kvs_player_options['logo_anchor'] == 'bottomleft') ? ' selected' : ''); ?>>Bottom-left</option>
                                </select>
                                X-offset: <input type="text" id="logo_position_x" name="logo_position_x" value="<?php echo $kvs_player_options['logo_position_x']; ?>" size="10"/>
                                Y-offset: <input type="text" id="logo_position_y" name="logo_position_y" value="<?php echo $kvs_player_options['logo_position_y']; ?>" size="10"/>
                                <p class="description">specify your logo position relative to player and offset in pixels</p>                                
                            </td>
                        </tr>
                        <tr>
                            <th scope="row">
                                Toolbar text:
                            </th>
                            <td>
                                <input type="text" id="mlogo" name="mlogo" value="<?php echo $kvs_player_options['mlogo']; ?>" size="40"/>
                                <input type="button" class="button" value="Example" onclick="$('#mlogo').val('Get more!')"/>
                                <p class="description">specify branding text you want to be displayed on toolbar</p>
                            </td>
                        </tr>
                        <tr>
                            <th scope="row">
                                Toolbar text click URL:
                            </th>
                            <td>
                                <input type="text" id="mlogo_link" name="mlogo_link" value="<?php echo $kvs_player_options['mlogo_link']; ?>" size="40"/>
                                <input type="button" class="button" value="Example" onclick="$('#mlogo_link').val('http://www.kernel-video-sharing.com/')"/>
                                <p class="description">specify where users will go if they click on your toolbar text</p>
                            </td>
                        </tr>
                    </table>
                    <br />
                    <?php wp_nonce_field('save_changes'); ?>
                    <input type="submit" name="save_changes" class="button-primary" value="Save Changes" />
                </div>
            </form>
        </div>
    </div>
    <?php
}

function kvs_player_advertising_menu() {
    global $kvs_player_options;
    ?>
    <script type="text/javascript" src="//ajax.googleapis.com/ajax/libs/jquery/1.10.2/jquery.min.js"></script>
    <script type="text/javascript" src="//ajax.googleapis.com/ajax/libs/jquery/1.10.2/jquery.min.js">
    </script>
    <div class="wrap">
        <h2>KVS Player Pro Advertising Settings</h2>
        <div class="metabox-holder postbox-container xpinner-settings">
            <form name="advertising_menu" action="" method="post">
                <div class="section" id="player_configurator_visual" style="display: block">
                    <table class="form-table">
                        <tr>
                            <th scope="row">
                                HTML code:
                            </th>
                            <td>
                                <textarea style="width:100%;" cols="60" rows="15" id="html_code" name="html_code"><?php echo stripslashes($kvs_player_options['html_code']); ?></textarea>
                                <p class="description">define the HTML ad boxes</p>
                            </td>
                        </tr>
                        <tr>
                            <th scope="row">
                                Click on video area:
                            </th>
                            <td>
                                <input type="text" id="video_click_url" name="video_click_url" value="<?php echo $kvs_player_options['video_click_url']; ?>" size="40"/>
                                <input type="button" class="button" value="Example" onclick="$('#video_click_url').val('http://www.kernel-video-sharing.com/')"/>
                                <p class="description">specify if player should open advertising when clicking on video area; if not - click will pause video</p>
                            </td>
                        </tr>
                        <tr>
                            <th scope="row">
                                Click behavior:
                            </th>
                            <td>
                                <select id="urls_in_same_window" name="urls_in_same_window">
                                    <option value=""<?php echo (($kvs_player_options['urls_in_same_window'] == '') ? ' selected' : ''); ?>>Open in new tab (window)</option>
                                    <option value="1"<?php echo (($kvs_player_options['urls_in_same_window'] == '1') ? ' selected' : '1'); ?>>Open in the same tab (window)</option>
                                </select>
                                <p class="description">specify how clicks on any branding / advertising must work</p>
                            </td>
                        </tr>
                        <th scope="row">
                            Start screen advertising:
                        </th>
                        <td>
                            <input type="text" id="adv_start_html_id" name="adv_start_html_id" value="<?php echo $kvs_player_options['adv_start_html_id']; ?>" size="40"/>
                            <input type="button" class="button" value="Example" onclick="$('#adv_start_html_id').val('player_adv_start')"/>
                            <p class="description">specify HTML id of the element, which should be centered on top of player before user starts video; this element can contain element with class="kt-api-btn-start", which will be automatically configured with "close" or "play" behavior</p>
                        </td>
                        </tr>
                        <tr>
                            <th colspan="2">Pre-roll advertising (before video starts playing)<hr /></th>
                        </tr>
                        <tr>
                            <th scope="row">
                                Advertising content:
                            </th>
                            <td>
                                <input type="hidden" name="adv_pre_roll_sw_html" value="">
                                <input type="checkbox" id="adv_pre_roll_sw_html" name="adv_pre_roll_sw_html" value="1"<?php if ($kvs_player_options['adv_pre_roll_sw_html'] == '1') echo " checked"; ?> onclick="$('#adv_pre_html_id, #adv_pre_html_example').prop('disabled', !this.checked);
                                            $('#adv_pre_duration, #adv_pre_duration_example').prop('disabled', !this.checked && !$('#adv_pre_roll_sw_flash').get(0).checked);">HTML-based
                                <input type="text" id="adv_pre_html_id" name="adv_pre_html_id" value="<?php echo $kvs_player_options['adv_pre_html_id']; ?>" size="40"<?php if ($kvs_player_options['adv_pre_roll_sw_html'] != '1') echo ' disabled="disabled"'; ?>/>
                                <input type="button" class="button" id="adv_pre_html_example" value="Example"<?php if ($kvs_player_options['adv_pre_roll_sw_html'] != '1') echo ' disabled="disabled"'; ?> onclick="$('#adv_pre_html_id').val('player_adv_pre')"/>
                                <p class="description">specify HTML id of the element, which should be centered on top of player as a pre-roll layer; this element can contain element with class="kt-api-time-left", which will be automatically updated with time when advertising ends</p>
                                <br/>
                                <input type="hidden" name="adv_pre_roll_sw_flash" value="">
                                <input type="checkbox" id="adv_pre_roll_sw_flash" name="adv_pre_roll_sw_flash" value="1"<?php if ($kvs_player_options['adv_pre_roll_sw_flash'] == '1') echo " checked"; ?> onclick="$('#adv_pre_src, #adv_pre_src_example, #adv_pre_url, #adv_pre_url_example').prop('disabled', !this.checked);
                                            $('#adv_pre_duration, #adv_pre_duration_example').prop('disabled', !this.checked && !$('#adv_pre_roll_sw_html').get(0).checked);">Flash-based
                                <input type="text" id="adv_pre_src" name="adv_pre_src" value="<?php echo $kvs_player_options['adv_pre_src']; ?>" size="40"<?php if ($kvs_player_options['adv_pre_roll_sw_flash'] != '1') echo ' disabled="disabled"'; ?>/>
                                <input type="button" class="button" id="adv_pre_src_example" value="Example"<?php if ($kvs_player_options['adv_pre_roll_sw_flash'] != '1') echo ' disabled="disabled"'; ?> onclick="$('#adv_pre_src').val('http://www.kernel-video-sharing.com/kt_player/advertising.jpg')"/>
                                <p class="description">specify image or video file location, which should be displayed in player as a pre-roll banner</p>
                            </td>
                        </tr>
                        <tr>
                            <th scope="row">
                                Advertising duration:
                            </th>
                            <td>
                                <input type="text" id="adv_pre_duration" name="adv_pre_duration" value="<?php echo $kvs_player_options['adv_pre_duration']; ?>" size="40"<?php if ($kvs_player_options['adv_pre_roll_sw_html'] != '1' && $kvs_player_options['adv_pre_roll_sw_flash'] != '1') echo ' disabled="disabled"'; ?>/>
                                <input type="button" class="button" id="adv_pre_duration_example" value="Example"<?php if ($kvs_player_options['adv_pre_roll_sw_html'] != '1' && $kvs_player_options['adv_pre_roll_sw_flash'] != '1') echo ' disabled="disabled"'; ?> onclick="$('#adv_pre_duration').val('10')"/>
                                <p class="description">specify advertising duration in seconds</p>
                            </td>
                        </tr>
                        <tr>
                            <th scope="row">
                                Click URL:
                            </th>
                            <td>
                                <input type="text" id="adv_pre_url" name="adv_pre_url" value="<?php echo $kvs_player_options['adv_pre_url']; ?>" size="40"<?php if ($kvs_player_options['adv_pre_roll_sw_flash'] != '1') echo ' disabled="disabled"'; ?>/>
                                <input type="button" class="button" id="adv_pre_url_example" value="Example"<?php if ($kvs_player_options['adv_pre_roll_sw_flash'] != '1') echo ' disabled="disabled"'; ?> onclick="$('#adv_pre_url').val('http://www.kernel-video-sharing.com/')"/>
                                <p class="description">specify on-click URL for Flash-based advertising; HTML-based advertising should has its own click logic in HTML code</p>
                            </td>
                        </tr>
                        <tr>
                            <th colspan="2">Post-roll advertising (after video ends)<hr /></th>
                        </tr>
                        <tr>
                            <th scope="row">
                                Advertising content:
                            </th>
                            <td>
                                <input type="hidden" name="adv_post_roll_sw_html" value="">
                                <input type="checkbox" id="adv_post_roll_sw_html" name="adv_post_roll_sw_html" value="1"<?php if ($kvs_player_options['adv_post_roll_sw_html'] == '1') echo " checked"; ?> onclick="$('#adv_post_html_id, #adv_post_html_example').prop('disabled', !this.checked);
                                            $('#adv_post_duration, #adv_post_duration_example').prop('disabled', !this.checked && !$('#adv_post_roll_sw_flash').get(0).checked);">HTML-based
                                <input type="text" id="adv_post_html_id" name="adv_post_html_id" value="<?php echo $kvs_player_options['adv_post_html_id']; ?>" size="40"<?php if ($kvs_player_options['adv_post_roll_sw_html'] != '1') echo ' disabled="disabled"'; ?>/>
                                <input type="button" class="button" id="adv_post_html_example" value="Example"<?php if ($kvs_player_options['adv_post_roll_sw_html'] != '1') echo ' disabled="disabled"'; ?> onclick="$('#adv_post_html_id').val('player_adv_post')"/>
                                <p class="description">specify HTML id of the element, which should be centered on top of player as a post-roll layer</p>
                                <br/>
                                <input type="hidden" name="adv_post_roll_sw_flash" value="">
                                <input type="checkbox" id="adv_post_roll_sw_flash" name="adv_post_roll_sw_flash" value="1"<?php if ($kvs_player_options['adv_post_roll_sw_flash'] == '1') echo " checked"; ?> onclick="$('#adv_post_src, #adv_post_src_example, #adv_post_url, #adv_post_url_example').prop('disabled', !this.checked);
                                            $('#adv_post_duration, #adv_post_duration_example').prop('disabled', !this.checked && !$('#adv_post_roll_sw_html').get(0).checked);">Flash-based
                                <input type="text" id="adv_post_src" name="adv_post_src" value="<?php echo $kvs_player_options['adv_post_src']; ?>" size="40"<?php if ($kvs_player_options['adv_post_roll_sw_flash'] != '1') echo ' disabled="disabled"'; ?>/>
                                <input type="button" class="button" id="adv_post_src_example" value="Example"<?php if ($kvs_player_options['adv_post_roll_sw_flash'] != '1') echo ' disabled="disabled"'; ?> onclick="$('#adv_post_src').val('http://www.kernel-video-sharing.com/kt_player/advertising.jpg')"/>
                                <p class="description">specify image or video file location, which should be displayed in player as a post-roll banner</p>
                            </td>
                        </tr>
                        <tr>
                            <th scope="row">
                                Advertising duration:
                            </th>
                            <td>
                                <input type="text" id="adv_post_duration" name="adv_post_duration" value="<?php echo $kvs_player_options['adv_post_duration']; ?>" size="40"<?php if ($kvs_player_options['adv_post_roll_sw_html'] != '1' && $kvs_player_options['adv_post_roll_sw_flash'] != '1') echo ' disabled="disabled"'; ?>/>
                                <input type="button" class="button" id="adv_post_duration_example" value="Example"<?php if ($kvs_player_options['adv_post_roll_sw_html'] != '1' && $kvs_player_options['adv_post_roll_sw_flash'] != '1') echo ' disabled="disabled"'; ?> onclick="$('#adv_post_duration').val('10')"/>
                                <p class="description">specify advertising duration in seconds</p>
                            </td>
                        </tr>
                        <tr>
                            <th scope="row">
                                Click URL:
                            </th>
                            <td>
                                <input type="text" id="adv_post_url" name="adv_post_url" value="<?php echo $kvs_player_options['adv_post_url']; ?>" size="40"<?php if ($kvs_player_options['adv_post_roll_sw_flash'] != '1') echo ' disabled="disabled"'; ?>/>
                                <input type="button" class="button" id="adv_post_url_example" value="Example"<?php if ($kvs_player_options['adv_post_roll_sw_flash'] != '1') echo ' disabled="disabled"'; ?> onclick="$('#adv_post_url').val('http://www.kernel-video-sharing.com/')"/>
                                <p class="description">specify on-click URL for Flash-based advertising; HTML-based advertising should has its own click logic in HTML code</p>
                            </td>
                        </tr>
                        <tr>
                            <th colspan="2">Advertising on pause<hr /></th>
                        </tr>
                        <tr>
                            <th scope="row">
                                Advertising content:
                            </th>
                            <td>
                                <input type="hidden" name="adv_pause_roll_sw_html" value="">
                                <input type="checkbox" id="adv_pause_roll_sw_html" name="adv_pause_roll_sw_html" value="1"<?php if ($kvs_player_options['adv_pause_roll_sw_html'] == '1') echo " checked"; ?> onclick="$('#adv_pause_html_id, #adv_pause_html_example').prop('disabled', !this.checked);">HTML-based
                                <input type="text" id="adv_pause_html_id" name="adv_pause_html_id" value="<?php echo $kvs_player_options['adv_pause_html_id']; ?>" size="40"<?php if ($kvs_player_options['adv_pause_roll_sw_html'] != '1') echo ' disabled="disabled"'; ?>/>
                                <input type="button" class="button" id="adv_pause_html_example" value="Example"<?php if ($kvs_player_options['adv_pause_roll_sw_html'] != '1') echo ' disabled="disabled"'; ?> onclick="$('#adv_pause_html_id').val('player_adv_pause')"/>
                                <p class="description">specify HTML id of the element, which should be centered on top of player when video playback is paused; this element can contain element with class="kt-api-btn-start", which will be automatically configured with "continue" behavior</p>
                                <br/>
                                <input type="hidden" name="adv_pause_roll_sw_flash" value="">
                                <input type="checkbox" id="adv_pause_roll_sw_flash" name="adv_pause_roll_sw_flash" value="1"<?php if ($kvs_player_options['adv_pause_roll_sw_flash'] == '1') echo " checked"; ?> onclick="$('#adv_pause_src, #adv_pause_src_example, #adv_pause_url, #adv_pause_url_example').prop('disabled', !this.checked);">Flash-based
                                <input type="text" id="adv_pause_src" name="adv_pause_src" value="<?php echo $kvs_player_options['adv_pause_src']; ?>" size="40"<?php if ($kvs_player_options['adv_pause_roll_sw_flash'] != '1') echo ' disabled="disabled"'; ?>/>
                                <input type="button" class="button" id="adv_pause_src_example" value="Example"<?php if ($kvs_player_options['adv_pause_roll_sw_flash'] != '1') echo ' disabled="disabled"'; ?> onclick="$('#adv_pause_src').val('http://www.kernel-video-sharing.com/kt_player/advertising.jpg')"/>
                                <p class="description">specify image location, which should be displayed in player as an on-pause banner</p>
                            </td>
                        </tr>
                        <tr>
                            <th scope="row">
                                Click URL:
                            </th>
                            <td>
                                <input type="text" id="adv_pause_url" name="adv_pause_url" value="<?php echo $kvs_player_options['adv_pause_url']; ?>" size="40"<?php if ($kvs_player_options['adv_pause_roll_sw_flash'] != '1') echo ' disabled="disabled"'; ?>/>
                                <input type="button" class="button" id="adv_pause_url_example" value="Example"<?php if ($kvs_player_options['adv_pause_roll_sw_flash'] != '1') echo ' disabled="disabled"'; ?> onclick="$('#adv_pause_url').val('http://www.kernel-video-sharing.com/')"/>
                                <p class="description">specify on-click URL for Flash-based advertising; HTML-based advertising should has its own click logic in HTML code</p>
                            </td>
                        </tr>
                        <tr>
                            <th colspan="2">Mouse over advertising<hr /></th>
                        </tr>
                        <tr>
                            <th scope="row">
                                Advertising content:
                            </th>
                            <td>
                                <input type="text" id="adv_mover_src" name="adv_mover_src" value="<?php echo $kvs_player_options['adv_mover_src']; ?>" size="40"/>
                                <input type="button" class="button" id="adv_mover_src_example" value="Example" onclick="$('#adv_mover_src').val('http://www.kernel-video-sharing.com/kt_player/mouseover.jpg')"/>
                                <p class="description">specify image location, which should be displayed in player as an mouse-over banner</p>
                            </td>
                        </tr>
                        <tr>
                            <th scope="row">
                                Click URL:
                            </th>
                            <td>
                                <input type="text" id="adv_mover_url" name="adv_mover_url" value="<?php echo $kvs_player_options['adv_mover_url']; ?>" size="40"/>
                                <input type="button" class="button" id="adv_mover_url_example" value="Example" onclick="$('#adv_mover_url').val('http://www.kernel-video-sharing.com/')"/>
                                <p class="description">specify on-click URL for this advertising</p>
                            </td>
                        </tr>
                    </table>
                    <br />
                    <?php wp_nonce_field('save_changes'); ?>
                    <input type="submit" name="save_changes" class="button-primary" value="Save Changes" />
                </div>
            </form>
        </div>
    </div>
    <?php
}

function kvs_player_get_link($link) {
    if (strlen($link) && !strlen(pathinfo($link, PATHINFO_EXTENSION))) {
        $custom_field = get_post_meta(get_the_ID(), $link, true);
        if (!empty($custom_field)) {
            if (is_array(custom_field)) {
                return $custom_field[0];
            }
            return $custom_field;
        }
    }
    return $link;
}

function kvs_player_encode($player) {
    $code = '<script language="Javascript">var keyStr="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";function kvs_decode(input){var output="";var chr1,chr2,chr3="";var enc1,enc2,enc3,enc4="";var i=0;input=input.replace(/[^A-Za-z0-9\+\/\=]/g,"");do{enc1=keyStr.indexOf(input.charAt(i++));enc2=keyStr.indexOf(input.charAt(i++));enc3=keyStr.indexOf(input.charAt(i++));enc4=keyStr.indexOf(input.charAt(i++));chr1=(enc1<<2)|(enc2>>4);chr2=((enc2&15)<<4)|(enc3>>2);chr3=((enc3&3)<<6)|enc4;output=output+String.fromCharCode(chr1);if(enc3!=64){output=output+String.fromCharCode(chr2)}if(enc4!=64){output=output+String.fromCharCode(chr3)}chr1=chr2=chr3="";enc1=enc2=enc3=enc4=""}while(i<input.length);return unescape(output)}document.write(kvs_decode("%%PLAYER%%"));</script>';
    return str_replace('%%PLAYER%%', base64_encode($player), $code);
}

function KVSFlvInsert($params) {
    global $kvs_player_options, $kvs_players, $codes, $post;

    if (is_array($params)) {
        $atts = $params;
    } else {
        @list($video_url, $preview_url, $width, $height, $video_click_url, $player) = preg_split('/\s+/u', $params);
        $atts = array();
        if (isset($video_url) && $video_url != '#') {
            $atts['video_url'] = $video_url;
        }
        if (isset($preview_url) && $preview_url != '#') {
            $atts['preview_url'] = $preview_url;
        }
        if (isset($width) && $width != '0') {
            $atts['width'] = $width;
        }
        if (isset($height) && $height != '0') {
            $atts['height'] = $height;
        }
        if (isset($video_click_url) && $video_click_url != '#') {
            $atts['video_click_url'] = $video_click_url;
        }
        if (isset($player) && $player != '#') {
            $atts['player'] = $player;
        }
    }

    if (!isset($atts['video_url'])) {
        $atts['video_url'] = '';
    } else {
        $atts['video_url'] = kvs_player_get_link(html_entity_decode($atts['video_url']));
    }

    if (!isset($atts['video_click_url'])) {
        $atts['video_click_url'] = kvs_player_get_link(html_entity_decode($kvs_player_options['video_click_url']));
    } else {
        $atts['video_click_url'] = kvs_player_get_link(html_entity_decode($atts['video_click_url']));
    }

    if (!isset($atts['preview_url'])) {
        $atts['preview_url'] = kvs_player_get_link(html_entity_decode($kvs_player_options['preview_url']));
    } else {
        $atts['preview_url'] = kvs_player_get_link(html_entity_decode($atts['preview_url']));
    }

    if (!isset($atts['player'])) {
        $atts['player'] = KVS_PLAYER_DEFAULT_PLAYER_SWF;
    } else {
        $atts['player'] = kvs_player_get_link(html_entity_decode($atts['player']));
    }

    foreach ($kvs_player_options as $option => $value) {
        if (!isset($atts[$option])) {
            $atts[$option] = $value;
        }
    }

    if ($kvs_player_options['iframe'] == '') {
        $postfix = ($kvs_players) ? '_' . $kvs_players : '';
    } else {
        $postfix = '';
    }

    if (strlen($atts['adv_start_html_id'] . $atts['adv_pre_html_id'] . $atts['adv_post_html_id'] . $atts['adv_pause_html_id'])) {
        $code = $atts['html_code'] . "\n\n";
        if ($kvs_players && $kvs_player_options['iframe'] == '') {
            $code = preg_replace('/player_adv_start|player_adv_pre|player_adv_post|player_adv_pause/s', '\\0' . $postfix, $code);
        }
    } else {
        $code = '';
    }

    if (!$kvs_players || $kvs_player_options['iframe'] != '') {
        $code .= "<script type=\"text/javascript\" src=\"" . KVS_PLAYER_DEFAULT_PLAYER_JS . "\"></script>\n";
    }

    $code .= "<div id=\"kt_player" . $postfix . "\" style=\"visibility: hidden\">\n";
    $code .= "    <a href=\"http://adobe.com/go/getflashplayer\">This page requires Adobe Flash Player</a>\n";
    $code .= "</div>\n";
    $code .= "<script type=\"text/javascript\">\n";
    $code .= "    var flashvars = {\n";

    $code .= "        video_url: '" . str_replace('×', 'x', $atts['video_url']) . "',\n";

    if ($atts['hide_controlbar'] != '') {
        $code .= "        hide_controlbar: '" . $atts['hide_controlbar'] . "',\n";
    }

    if ($atts['hide_style'] != '') {
        $code .= "        hide_style: '" . $atts['hide_style'] . "',\n";
    }

    if ($atts['preview_url'] != '') {
        $code .= "        preview_url: '" . str_replace('×', 'x', $atts['preview_url']) . "',\n";
    }

    if ($atts['embed'] != '') {
        $code .= "        embed: '" . $atts['embed'] . "',\n";
    }

    if ($atts['permalink'] != '') {
        $code .= "        permalink_url: '" . get_permalink() . "',\n";
    }

    if ($atts['sec'] != '') {
        $code .= "        sec: '" . $atts['sec'] . "',\n";
    }

    if ($atts['scaling'] != '') {
        $code .= "        scaling: '" . $atts['scaling'] . "',\n";
    }

    if ($atts['skin'] != '') {
        $code .= "        skin: '" . $atts['skin'] . "',\n";
    }

    if (($atts['autoplay'] == '1' && (is_single() || is_page())) || $atts['autoplay'] == '2') {
        $code .= "        autoplay: 'true',\n";
    }

    if ($atts['video_click_url'] != '') {
        $code .= "        video_click_url: '" . $atts['video_click_url'] . "',\n";
    }

    if ($atts['urls_in_same_window'] != '') {
        $code .= "        urls_in_same_window: '" . $atts['urls_in_same_window'] . "',\n";
    }

    if ($atts['flv_stream'] != '') {
        $code .= "        flv_stream: '" . $atts['flv_stream'] . "',\n";
    }

    if ($atts['logo_src'] != '') {
        $code .= "        logo_src: '" . $atts['logo_src'] . "',\n";
    }

    if ($atts['logo_url'] != '') {
        $code .= "        logo_url: '" . $atts['logo_url'] . "',\n";
    }

    if ($atts['logo_anchor'] != '') {
        $code .= "        logo_anchor: '" . $atts['logo_anchor'] . "',\n";
    }

    if ($atts['mlogo'] != '') {
        $code .= "        mlogo: '" . $atts['mlogo'] . "',\n";
    }

    if ($atts['mlogo_link'] != '') {
        $code .= "        mlogo_link: '" . $atts['mlogo_link'] . "',\n";
    }

    if ($atts['logo_position_x'] != '0' || $atts['logo_position_y'] != '0') {
        $code .= "        logo_position: '[" . $atts['video_url'] . "]',\n";
    }

    if ($atts['adv_start_html_id'] != '') {
        $code .= "        adv_start_html_id: '" . $atts['adv_start_html_id'] . $postfix . "',\n";
    }

    if ($atts['adv_pre_html_id'] != '') {
        $code .= "        adv_pre_html_id: '" . $atts['adv_pre_html_id'] . $postfix . "',\n";
    }

    if ($atts['adv_pre_src'] != '') {
        $code .= "        adv_pre_src: '" . $atts['adv_pre_src'] . "',\n";
    }

    if ($atts['adv_pre_duration'] != '') {
        $code .= "        adv_pre_duration: '" . $atts['adv_pre_duration'] . "',\n";
    }

    if ($atts['adv_pre_url'] != '') {
        $code .= "        adv_pre_url: '" . $atts['adv_pre_url'] . "',\n";
    }

    if ($atts['adv_post_html_id'] != '') {
        $code .= "        adv_post_html_id: '" . $atts['adv_post_html_id'] . $postfix . "',\n";
    }

    if ($atts['adv_post_src'] != '') {
        $code .= "        adv_post_src: '" . $atts['adv_post_src'] . "',\n";
    }

    if ($atts['adv_post_duration'] != '') {
        $code .= "        adv_post_duration: '" . $atts['adv_post_duration'] . "',\n";
    }

    if ($atts['adv_post_url'] != '') {
        $code .= "        adv_post_url: '" . $atts['adv_post_url'] . "',\n";
    }

    if ($atts['adv_pause_html_id'] != '') {
        $code .= "        adv_pause_html_id: '" . $atts['adv_pause_html_id'] . $postfix . "',\n";
    }

    if ($atts['adv_pause_src'] != '') {
        $code .= "        adv_pause_src: '" . $atts['adv_pause_src'] . "',\n";
    }

    if ($atts['adv_pause_url'] != '') {
        $code .= "        adv_pause_url: '" . $atts['adv_pause_url'] . "',\n";
    }

    if ($atts['adv_mover_src'] != '') {
        $code .= "        adv_mover_src: '" . $atts['adv_mover_src'] . "',\n";
    }

    if ($atts['adv_mover_url'] != '') {
        $code .= "        adv_mover_url: '" . $atts['adv_mover_url'] . "',\n";
    }

    $code .= "        bt: '" . $atts['bt'] . "',\n";
    $code .= "    };\n";
    $code .= "    var params = {allowfullscreen: 'true', allowscriptaccess: 'always'};\n";

    if ($kvs_player_options['iframe'] != '') {
        $code .= "    kt_player('kt_player" . "', '" . $atts['player'] . "', '100%', '100%', flashvars, params);\n";
        $div = (strpos(get_permalink($post->ID), '?') === false) ? ('?') : ('&');
        $iframe = '<iframe src="' . get_permalink($post->ID) . $div . 'kvs_video_id=' . $kvs_players . '" frameborder="0" width="' . $atts['width'] . '" height="' . $atts['height'] . '" id="kt_player" id="kt_player_internal" scrolling="no" allowfullscreen webkitallowfullscreen mozallowfullscreen oallowfullscreen msallowfullscreen></iframe>';
        $code .= "    function getEmbed() {\n";
        $code .= "        return '$iframe';\n";
        $code .= "    }\n";
        $code .= "</script>\n";
        if ($kvs_player_options['encode'] !== '') {
            $code = kvs_player_encode($code);
        }
        $codes[] = $code;
        update_post_meta($post->ID, 'kvs_player_video_list', $codes);
        $res = $iframe;
    } else {
        $code .= "    kt_player('kt_player" . $postfix . "', '" . $atts['player'] . "', '" . $atts['width'] . "', '" . $atts['height'] . "', flashvars, params);\n";
        $code .= "</script>\n";
        if ($kvs_player_options['encode'] !== '') {
            $code = kvs_player_encode($code);
        }
        $res = $code;
    }

    $kvs_players++;
    return $res;
}

function kvs_player_shortcode($atts) {
    return KVSFlvInsert($atts);
}

function kvs_player_content($content) {
    // old shortcode format
    if (version_compare(phpversion(), '5.4.0', '>=')) {
        $content = preg_replace_callback("'\[flv:(.*?)\]'i", function ($matches) {
            return stripslashes(KVSFlvInsert($matches[1]));
        }, $content);
    } else {
        $content = preg_replace("'\[flv:(.*?)\]'ie", "stripslashes(KVSFlvInsert('\\1'))", $content);
    }
    // new shortcode format
    add_shortcode('kvs_player', 'kvs_player_shortcode');
    if (has_shortcode($content, 'kvs_player')) {
        $pattern = get_shortcode_regex();
        $content = preg_replace_callback("/$pattern/s", 'do_shortcode_tag', $content);
    }
    remove_shortcode('kvs_player');
    return $content;
}

function kvs_player_play_video() {
    global $post;
    $codes = get_post_meta($post->ID, 'kvs_player_video_list', true);
    $video_id = intval($_GET['kvs_video_id']);
    if (isset($codes[$video_id])) {
        echo $codes[$video_id];
        die();
    }
}

if ($kvs_player_options['iframe'] != '' && isset($_GET['kvs_video_id'])) {
    add_action('get_header', 'kvs_player_play_video');
} else {
    add_filter('the_content', 'kvs_player_content');
    add_filter('the_excerpt', 'kvs_player_content');
}

function kvs_player_main_menu() {
    add_menu_page('General Options', 'KVS Player Pro', 'manage_options', 'kvs-player-pro', 'kvs_player_general_options_menu', 'dashicons-format-video');
    add_submenu_page('kvs-player-pro', 'Branding Settings', 'Branding Settings', 'manage_options', 'kvs-player-pro-branding-menu', 'kvs_player_branding_menu');
    add_submenu_page('kvs-player-pro', 'Advertising Settings', 'Advertising Settings', 'manage_options', 'kvs-player-pro-advertising-menu', 'kvs_player_advertising_menu');
}

if (is_admin()) {
    add_action('admin_menu', 'kvs_player_main_menu');
}
?>